/*
 * Copyright 2016 - 2023 Gary Talent (gary@drinkingtea.net). All rights reserved.
 */

#include <ox/std/array.hpp>

#include <nostalgia/foundation/module.hpp>

#include <nostalgia/core/module.hpp>
#include <nostalgia/scene/scenemodule.hpp>

namespace nostalgia {

static bool modulesLoaded = false;
void loadModules() noexcept {
	if (modulesLoaded) {
		return;
	}
	const ox::Array<foundation::Module*, 2> mods = {
		&core::CoreModule::mod,
		&scene::SceneModule::mod,
	};
	for (const auto m : mods) {
		foundation::registerModule(m);
	}
	modulesLoaded = true;
}

}
