/*
 * Copyright 2016 - 2023 Gary Talent (gary@drinkingtea.net). All rights reserved.
 */

#pragma once

#include <nostalgia/foundation/module.hpp>

#include "typeconv.hpp"

namespace nostalgia::core {

class CoreModule: public foundation::Module {
	private:
		NostalgiaPaletteToPaletteConverter nostalgiaPaletteToPaletteConverter;
		TileSheetV1ToTileSheetConverter nostalgiaGraphicToTileSheetConverter;
		TileSheetToCompactTileSheetConverter tileSheetToCompactTileSheetConverter;
		TileSheetV2ToTileSheetConverter tileSheetV2ToTileSheetConverter;

	public:
		static CoreModule mod;
		[[nodiscard]]
		ox::Vector<foundation::TypeDescGenerator> types() const noexcept override;
		[[nodiscard]]
		ox::Vector<const foundation::BaseConverter*> converters() const noexcept override;
		[[nodiscard]]
		ox::Vector<foundation::PackTransform> packTransforms() const noexcept override;
};

}
