/*
 * Copyright 2016 - 2023 Gary Talent (gary@drinkingtea.net). All rights reserved.
 */

#pragma once

#include <ox/std/def.hpp>

#include <nostalgia/foundation/typeconv.hpp>

#include "context.hpp"
#include "gfx.hpp"

namespace nostalgia::core {

// Type converters

class NostalgiaPaletteToPaletteConverter: public foundation::Converter<NostalgiaPalette, Palette> {
	ox::Error convert(foundation::Context*, NostalgiaPalette *src, Palette *dst) const noexcept final;
};

class TileSheetV1ToTileSheetConverter: public foundation::Converter<TileSheetV1, TileSheet> {
	ox::Error convert(foundation::Context*, TileSheetV1 *src, TileSheet *dst) const noexcept final;
};

class TileSheetToCompactTileSheetConverter: public foundation::Converter<TileSheet, CompactTileSheet> {
	ox::Error convert(foundation::Context*, TileSheet *src, CompactTileSheet *dst) const noexcept final;
};

class TileSheetV2ToTileSheetConverter: public foundation::Converter<TileSheetV2, TileSheet> {
	static void convertSubsheet(
			TileSheetV2::SubSheet *src,
			TileSheet::SubSheet *dst,
			SubSheetId *idIt) noexcept;

	ox::Error convert(foundation::Context*, TileSheetV2 *src, TileSheet *dst) const noexcept final;

};

}
