/*
 * Copyright 2016 - 2023 Gary Talent (gary@drinkingtea.net). All rights reserved.
 */

#include <ox/model/model.hpp>

#include "scenestatic.hpp"
#include "scenemodule.hpp"

namespace nostalgia::scene {

SceneModule SceneModule::mod;

ox::Vector<foundation::TypeDescGenerator> SceneModule::types() const noexcept {
	return {
		foundation::generateTypeDesc<SceneDoc>,
		foundation::generateTypeDesc<SceneStatic>,
	};
}

ox::Vector<const foundation::BaseConverter*> SceneModule::converters() const noexcept {
	return {
		&sceneDocToSceneStaticConverter,
	};
}

ox::Vector<foundation::PackTransform> SceneModule::packTransforms() const noexcept {
	return {
		foundation::transformRule<SceneDoc, SceneStatic>,
	};
}

}
